# -*- coding: utf-8 -*-
import sys, time, weakref
#from PySide import QtCore, QtGui  ## bug is not present in PySide
from PyQt4 import QtCore, QtGui

app = QtGui.QApplication([])

def test():
    for c in range(5000):
        if c%100 == 0:
            sys.stdout.write('.')
        sys.stdout.flush()
        
        ## Create a GraphicsView and an item linking back to it
        w = QtGui.QGraphicsView()
        s = QtGui.QGraphicsScene()
        w.setScene(s)
        i = QtGui.QGraphicsRectItem(0,0,1,1)
        s.addItem(i)
        
        i.view = w          ## <-- this is crucial
        #i.view = weakref.ref(w)
        
        app.processEvents()
    print "OK"
         

def doWork():
    while True:
        x = '.'.join(['%f'%i for i in range(100)])  ## some work for the thread to do
        if time is None:  ## main thread has started cleaning up, bail out now
            break
        time.sleep(1e-3)

## Another thread must be active (python threads and QThreads both work)
#class Thread(QtCore.QThread):
    #def run(self):
        #doWork()
#th = Thread()  
#th.start()    

import thread
thread.start_new_thread(doWork, ())

test()

